/**
 * Обработчик формы добавления материалов модуля /load/
 * @author N-Torrents.ru <feniwe@gmail.com>
 * @version 2.1
 */

var _nAddFormTemplates = {
    'films'              : '[u]Информация о фильме[/u]\n[b]Название:[/b] Название на русском языке\n[b]Оригинальное название:[/b] Название на языке оригинала\n[b]Год выхода:[/b] здесь и далее оставляйте пробел после двоеточия!\n[b]Жанр:[/b] \n[b]Режиссер:[/b] \n[b]В ролях:[/b]\n\n[b]Сюжет фильма:[/b]\nКраткое содержание сюжетной линии фильма (серии, если это сериал)\n\n[kinopoisk]Здесь нужно указать ID фильма на сайте KinoPoisk.ru[/kinopoisk]\n\n[b]Производство:[/b] студия-производитель, страна\n[b]Продолжительность:[/b] время воспроизведения в формате чч:мм:сс\n[b]Перевод:[/b] укажите вид перевода и озвучания\nа) дубляж\nб) профессиональный многоголосный\nв) профессиональный одноголосный\nг) любительский многоголосный\nд) любительский одноголосный\nе) другое ( авторские переводы и озвучание с указанием авторов )\n\n[u]Файл[/u]\n[b]Качество | Источник:[/b] DVDRip, BDRip, DVD5, TVRip и т.д.\n[b]Видео:[/b] кодек (DivX, XviD и тд.), битрейт, разрешение и другие тех. параметры видео\n[b]Аудио:[/b] кодек (MP3, АC3 и тд.), битрейт и другие тех. параметры аудио\n\n[url=ссылка на отрывок из фильма][img]http://n-torrents.ru/sample.png[/img][/url] (Обязательный пункт для фильмов CAMRip, TS качества!)\n\n[spoiler=Скриншоты:]\n[c][screens]\n\nПрямые ссылки на скриншоты\n\n[/screens][/c]\n[/spoiler]',
    'pc'                 : '[b]Название:[/b] здесь и далее оставляйте пробел после двоеточия!\n[b]Год выхода:[/b] \n[b]Жанр:[/b] название жанра желательно брать с AG.ru\n[b]Разработчик:[/b] \n[b]Издатель:[/b] \n[b]Язык интерфейса:[/b] \n[b]Лекарство:[/b]\n\n[b]Системные требования:[/b]\nУкажите системные требования игры\n\n[b]Описание:[/b]\nОписание игры: сюжетная линия, особенности и так далее..\n\n[b]Скриншоты:[/b]\n[c][screens]\n\nПрямые ссылки на скриншоты\n\n[/screens][/c]\n\n[b]Релиз от:[/b] название или логотип релиз-группы/ресурса или ник/логотип рипера, если они вам известны',
    'psp'                : '[b]Название:[/b] здесь и далее оставляйте пробел после двоеточия!\n[b]Год выхода:[/b] \n[b]Жанр:[/b] \n[b]Разработчик:[/b] \n[b]Издатель:[/b] \n[b]Язык интерфейса:[/b]\n\n[b]Системные требования:[/b]\n\n[b]Описание:[/b]\n\n[b]Скриншоты:[/b] \n\n[b]Релиз от:[/b] название или логотип релиз-группы/ресурса или ник/логотип рипера, если они вам известны',
    'music'              : '[b]Исполнитель:[/b] здесь и далее оставляйте пробел после двоеточия!\n[b]Альбом:[/b] \n[b]Жанр:[/b] \n[b]Количество композиций:[/b] \n[b]Время звучания:[/b] \n[b]Параметры файлов:[/b] MP3 / 320 kbps / 44.1kHz/ Joint-Stereo\n\n[b]Композиции:[/b]',
    'software'           : '[b]Название:[/b] \n[b]Версия:[/b] \n[b]Платформа:[/b] \n[b]Язык интерфейса:[/b] \n[b]Год выхода:[/b] \n[b]Разработчик:[/b] \n[b]Лекарство:[/b] \n\n[b]Описание:[/b]\n\n[b]Скриншоты:[/b]\n\n',
    'e-book'             : '[b]Название:[/b] \n[b]Жанр:[/b] \n[b]Автор:[/b] \n[b]Страна:[/b] \n[b]Формат:[/b] \n\n[b]Описание:[/b]\n\n',
    'journal'            : '[b]Название:[/b] \n[b]Месяц и год выпуска:[/b] \n[b]Язык:[/b] \n[b]Количество страниц:[/b] \n[b]Формат:[/b] \n[b]Качество:[/b] \n\n[b]Описание:[/b]\n\n',
    'video'              : '[u]Информация о клипе[/u]\n[b]Композиция:[/b] здесь и далее оставляйте пробел после двоеточия!\n[b]Исполнитель:[/b] \n[b]Год выхода:[/b] \n[b]Жанр:[/b] \n[b]Продолжительность:[/b] время воспроизведения в формате чч:мм:сс\n\n[u]Файл[/u]\n[b]Качество | Источник:[/b] DVDRip, BDRip, DVD5, TVRip и т.д.\n\n[b]Видео:[/b] кодек (DivX, XviD и тд.), битрейт, разрешение и другие тех. параметры видео\n[b]Аудио:[/b] кодек (MP3, АC3 и тд.), битрейт и другие тех. параметры аудио\n\n[b]Кадры:[/b]\n\n[b]Релиз от:[/b] название или логотип релиз-группы/ресурса или ник/логотип рипера, если они вам известны',
    'wallpapers'         : '[b]Описание:[/b] (Не обязателный пункт)\n\n[b]Количество:[/b]\n[b]Размер изображений по ширине:[/b]',
    'audiobook'          : '[b]Название:[/b] \n[b]Жанр:[/b] \n[b]Автор:[/b] \n[b]Чтец:[/b] \n[b]Параметры файлов:[/b] \n\n[b]Описание:[/b]\n\n',
    'sample'             : '\n[url=ссылка на отрывок из фильма][img]http://n-torrents.ru/sample.png[/img][/url]',
    'kinopoisk'          : '\n[kinopoisk]ID Фильма на КиноПоиск.РУ[/kinopoisk]',
    'screenshots'        : '[b]Скриншоты:[/b]\n\n[c][screens]\n\nПрямые ссылки на скриншоты\n\n[/screens][/c]',
    'screenshots-spoiler': '[spoiler=Скриншоты:]\n[c][screens]\n\nПрямые ссылки на скриншоты\n\n[/screens][/c]\n[/spoiler]',
    'spoiler'            : '\n[spoiler=ВВЕДИТЕ НАЗВАНИЕ СПОЙЛЕРА]\nСодержимое спойлера\n[/spoiler]'
};
var _nAddFormCategories = {};
var _nAddFormSectionId = 0;
var _nAddFormRelated;
var _nAddFormFields;

jQuery(function() {
    _nAddFormPolyfills();
    // поиск таких же материалов
    _nAddFormSimilar();
    // инициализация категорий и переключение полей
    _nAddFormRelated = $('.js_related');
    _nAddFormCategoriesInit();
    // генерация тегов
    _nAddFormTags();
    // вставка шаблонов оформления
    _nAddFormInsertTemplate();
    // функционал выбора файла
    _nAddFormFileBehavior();
    // форматирование вида списка настроек раздачи
    _nAddFormFormatSettings();
    // всплывающие подсказки доп. полей
    _nAddFormSuggests();
    // поля для валидации
    _nAddFormFields = $('.js_validate');
    // функционал отправки формы
    _nAddFormSubmit();
    // отмечаем опцию редиректа после сохранения и разрешаем добавление комментариев в любом случае
    $('input[name="goto"], input[name="coms_allowed"]').prop('checked', true).attr('checked', 'checked');
    // клик по кнопке очистки полей снова проставляет некоторым checkbox'ам значение checked
    $('.addform__clear').click(function() {
        $('input[name="goto"], input[name="coms_allowed"]').prop('checked', true).attr('checked', 'checked');
    });
    // отображение и скрытие поля ввода индивидуального url
    var unique_url_checkbox = $('#settitlekeydesc');
    var unique_url_block = $('.addform__field_unique-url');
    if (unique_url_checkbox && unique_url_checkbox.length && unique_url_block && unique_url_block.length) {
        unique_url_checkbox.change(function() {
            if (!unique_url_checkbox.is(':checked')) {
                unique_url_block.addClass('hidden');
            } else {
                unique_url_block.removeClass('hidden');
            }
        });
        unique_url_checkbox.trigger('change');
    }
    // запрет скачивания на территории РФ
    var download_access_checkbox = $('#aname_check');
    var download_access_input = $('#ldF12');
    if (download_access_checkbox && download_access_checkbox.length && download_access_input && download_access_input.length) {
        download_access_checkbox.change(function() {
            if (download_access_checkbox.is(':checked')) {
                download_access_input.val('1');
            } else {
                download_access_input.val('0');
            }
        });
        download_access_checkbox.prop('checked', parseInt(download_access_input.val()) === 1);
    }
    // добавление дополнительных кнопок в bb-редактор
    $('#txtPart555brief input[value="img"]').parent().after('<span style="padding-right:1px;"><input type="button" title="Video" value="video" onclick="_nAddFormInsertVideo(\'brief\',\'\');" class="codeButtons"></span>');
    $('#txtPart555message input[value="img"]').parent().after('<span style="padding-right:1px;" id="bc0"><input type="button" title="Video" value="video" onclick="_nAddFormInsertVideo(\'message\',\'\');" class="codeButtons"></span>');
    $('#txtPart555message input[value="All codes"]').parent().after('<span style="padding-right:1px;"><input type="button" title="Выделить основную информацию тегами [b][/b]" value="BBT" onclick="_nAddFormHightlightImportant();" class="codeButtons" id="bbt"></span>');
    // поиск трейлеров к PC-играм
    $('#ldF1').blur(_nAddFormTrailer);
    // запрет прокрутки блока с загрузкой
    var overlay = $('.addform__load');
    if (overlay) {
        overlay.on('onwheel MozMousePixelScroll mousewheel touchmove', function(e) {
            e.preventDefault();
        });
    }
});

/**
 * Полифиллы
 * @return {undefined}
 */
function _nAddFormPolyfills() {
    if ( (!document.addEventListener) && document.attachEvent ) {
        Object.defineProperty(Element.prototype, 'addEventListener', function(eventName, func) {
            var self = this;
            self['e' + eventName + func] = fn;
            self[eventName + func] = function() {
                obj['e' + eventName + func]( window.event );
            };
            self.attachEvent('on' + eventName, self[eventName + func] );
        });
    }
    if (!('classList' in Element.prototype)) {
        var testRegExp = function(name) {
            return new RegExp('(^| )'+ name +'( |$)');
        };
        var forEach = function(list, fn, scope) {
            for (var i = 0; i < list.length; i++) {
                fn.call(scope, list[i]);
            }
        };
        function ClassList(element) {
            this.element = element;
        }
        ClassList.prototype = {
            add: function() {
                forEach(arguments, function(name) {
                    if (!this.contains(name)) {
                        this.element.className += ' ' + name;
                    }
                }, this);
                this.element.className = this.element.className.trim();
            },
            remove: function() {
                forEach(arguments, function(name) {
                    this.element.className = this.element.className.replace(testRegExp(name), ' ').trim();
                }, this);
            },
            toggle: function(name) {
                return this.contains(name) ? (this.remove(name), false) : (this.add(name), true);
            },
            contains: function(name) {
                return testRegExp(name).test(this.element.className);
            }
        };
        Object.defineProperty(Element.prototype, 'classList', {
            get: function() {
                return new ClassList(this);
            }
        });
    }
    if (!String.prototype.trim) {
        String.prototype.trim = function() {
            return this.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
        };
    }
}

/**
 * Заполняет блок с категориями
 * @return {undefined}
 */
function _nAddFormCategoriesInit() {
    // создаем объект с данными о разделах и категориях
    var source = $('#uCatsMenu9');
    source.children('div').each(function() {
        var self = $(this);
        var checkbox = self.find('input[type="checkbox"]');
        if (checkbox.attr('data-sectid')) { // Раздел (например, Фильмы)
            _nAddFormCategories['section' + checkbox.attr('data-sectid')] = {
                'name': self.text(),
                'content': '',
                'id': checkbox.attr('data-sectid')
            };
        } else if (checkbox.attr('data-parentID')) { // Категория (например, Фэнтези)
            _nAddFormCategories['section' + checkbox.attr('data-parentID')].content += '<div class="addform-categories__child">' + self.html() + '</div>';
            if (checkbox.is(':checked')) {
                _nAddFormSectionId = checkbox.attr('data-parentID');
            }
        }
    });
    // удаляем сгенерированное системой меню выбора категорий
    source.parents('.hidden').replaceWith('');
    // генерируем список разделов
    var sections = $('.addform-categories__parents');
    var sections_html = '';
    for (section in _nAddFormCategories) {
        if (_nAddFormCategories.hasOwnProperty(section)) {
            sections_html += '<a class="addform-categories__parent addform-categories__parent' + _nAddFormCategories[section].id + '">' + _nAddFormCategories[section].name + '</a>';
        }
    }
    sections.html(sections_html);
    // добавляем обработчики клика по разделу
    $('.addform-categories__parent').each(function() {
        var _self = $(this);
        var match = _self.attr('class').match(/addform-categories__parent(\d+)/i);
        if (!match || match && match.length < 2) {
            return;
        }
        _self.click(function() {
            _nAddFormSelectSection(match[1]);
        });
    });
    // отображаем выбранный раздел (или по-умолчанию раздел фильмов, id: 17)
    _nAddFormSelectSection(_nAddFormSectionId > 0 ? _nAddFormSectionId : 17);
}

/**
 * Выводит категории раздела с указанным идентификатором раздела (например, id: 17 для раздела "Фильмы")
 * и скрывает/отображает связанные с разделом поля (через классы, например, js_related js_related-17 для раздела "Фильмы")
 * @param {Number} id - идентификатор раздела
 * @return {undefined}
 */
function _nAddFormSelectSection(id) {
    var categories = $('.addform-categories__children');
    if (!categories || categories && categories.length === 0) {
        return;
    }
    if (!id || id <= 0 || !_nAddFormCategories.hasOwnProperty('section' + id)) {
        id = 17;
    }
    if (!_nAddFormCategories.hasOwnProperty('section' + id)) {
        return;
    }
    _nAddFormSectionId = id;
    // вывод категорий
    var section = _nAddFormCategories['section' + id];
    categories.html(section.content);
    $('.addform-categories__parent.active').removeClass('active');
    $('.addform-categories__parent' + id).addClass('active');
    // скрытие/отображение связанных полей
    if (_nAddFormRelated && _nAddFormRelated.length) {
        _nAddFormRelated.each(function() {
            var self = $(this);
            if (self.hasClass('js_related-' + id)) {
                self.removeClass('hidden');
            } else {
                self.addClass('hidden');
                self.find('input[type="text"], input[type="url"], input[type="number"]').val('');
            }
        });
    }
    // получение трейлера если выбран раздел "Игры для PC"
    _nAddFormTrailer();
}

/**
 * Вызывает функцию добавления текста в поле
 * @param {String} field_id - идентификатор поля-тега, в который производится вставка bb-кода
 * @return {undefined}
 */
function _nAddFormInsertVideo(field_id) {
    var url = prompt('Video URL',"http://");
    if (!url || url === 'http://' || url.length <= 11) {
        return;
    }
    doInsert("[video]" + url + "[/video]", "", false, field_id);
}

/**
 * Выделяет ключевую информацию тегами [b]...[/b]
 * @return {undefined}
 */
function _nAddFormHightlightImportant() {
    var textarea = document.getElementById('message');
    textarea.value = textarea.value.replace(/^(.+?)([:])/img, '[b]$1:[/b]');
}

/**
 * Активирует функционал обертки выбора файла
 * @return {undefined}
 */
function _nAddFormFileBehavior() {
    $('.addform__file').each(function() {
        var wrapper = $(this);
        var button = wrapper.find('.addform__file-button');
        var remove = wrapper.find('.addform__file-delete');
        var name = wrapper.find('.addform__file-name span');
        var input = wrapper.find('input[type="file"]');
        var link = wrapper.find('a');
        var checkbox = wrapper.find('input[type="checkbox"]');
        var filename = '';
        if (link.html()) {
            name.text(cropFileName(link.text()));
        } else {
            name.text('Файл не выбран');
        }
        button.click(function() {
            input.click();
        });
        input.change(function(event) {
            var files = event.target.files;
            if (files && files[0]) {
                name.text(cropFileName(files[0].name));
                if (link.html()) {
                    checkbox.prop('checked', true);
                    if (remove) {
                        remove.removeClass('button_gray').addClass('button_red');
                    }
                }
            } else if (link.html()) {
                name.text(cropFileName(files[0].name));
                checkbox.prop('checked', true);
                if (remove) {
                    remove.removeClass('button_gray').addClass('button_red');
                }
            } else {
                name.text('Файл не выбран');
            }
        });
        if (remove) {
            remove.click(function() {
                if (!link.html()) {
                    _uWnd.alert('Нет файла для удаления', 'Внимание', { w:250, h:92, tm:2500 });
                    return;
                }
                if (checkbox.prop('checked')) {
                    checkbox.prop('checked', false);
                    remove.removeClass('button_red').addClass('button_gray');
                } else {
                    checkbox.prop('checked', true);
                    remove.removeClass('button_gray').addClass('button_red');
                }
            });
        }
        // проставляем максимальный размер файла
        maxSize(wrapper);
    });

    /**
     * Обрезает название файла
     * @param {String} str - полное имя файла
     * @return {String}
     */
    function cropFileName(str) {
        str = str.substr(str.lastIndexOf('\\') + 1);
        if (str.length > 40) {
            str = str.substr(0, 20) + '...' + str.substr(str.length - 15);
        }

        return str;
    }

    /**
     * Проставляет максимальный размер файла
     * @param {Object} wrapper - Обернутный элемент, внутри которого расположен <span class="bold"> - тег, в котором находится значение максимального размера
     * @return {undefined}
     */
    function maxSize(wrapper) {
        var block = wrapper.find('.addform__file-button .bold');
        if (!block || block && !block.length) {
            return;
        }
        var matches = wrapper.html().match(/max[.]\s*<b>(\d+)<\/b>/i);
        if (!matches || matches && matches.length < 3) {
            return;
        }
        var count = matches[1];
        var units = 'Кб';
        if (count >= 1024) {
            count /= 1024;
            units = 'Мб';
        }
        count = Math.floor(count);
        block.text('< ' + count + ' ' + units);
    }

}

/**
 * Вставка шаблона оформления в поле подробного описания
 * @return {undefined}
 */
function _nAddFormInsertTemplate() {
    $('.addform__template').each(function() {
        var self = $(this);
        var matches = self.attr('class').match(/addform__template_([\w\d\-_]+)/i);
        if (!matches || matches && matches.length < 2) {
            return;
        }
        if (!_nAddFormTemplates[matches[1]]) {
            return;
        }
        self.click(function(e) {
            e = e || window.event;
            e.preventDefault();
            if (!_nAddFormTemplates[matches[1]]) {
                return;
            }
            doInsert(_nAddFormTemplates[matches[1]], '', false, 'message');
        });
    });
}

/**
 * Функционал поиска таких же раздач
 * @return {undefined}
 */
function _nAddFormSimilar() {
    var input = $("#ldF1");
    var button = $('.addform__similar-button');
    var clear = $('.addform__similar-clear');
    var block = $('.addform__similar-results');
    var status = $('.addform__similar-status');
    var results = $('.addform__similar-entries');
    var ready = true;
    if (!input || input && !input.length || !button || button && !button.length || !block || block && !block.length) {
        return;
    }
    if (!status || status && !status.length || !results || results && !results.length) {
        return;
    }
    button.click(function () {
        if (!ready) {
            return;
        }
        if (input.val().match(/^\s*$/)) {
            _uWnd.alert('Не заполнено поле "Название раздачи"', 'Внимание', {w:250, h:92, tm:2500});
            return;
        }
        ready = false;
        setEnabled(false);
        button.addClass('hidden');
        block.removeClass('hidden');
        status.removeClass('hidden').text('Идёт поиск, пожалуйста, подождите...');
        results.addClass('hidden').html('');
        $.ajax({
            type: 'POST',
            url: '/load/',
            data: { query: input.val(), a: 2 },
            timeout: 8000,
            success: function(data) {
                clear.removeClass('hidden');
                var entries = $('.search-results__item', data);
                if (!entries || entries && !entries.length) {
                    status.text('Похожих материалов не найдено.');
                } else {
                    status.addClass('hidden');
                    results.removeClass('hidden');
                    entries.each(function() {
                        var element = this;
                        element.className = 'search-results__item';
                        if (element.children && element.children.length > 1) {
                            element.removeChild(element.children[1]);
                        }
                        results.append(element);
                    });
                }
                setEnabled(true);
                ready = true;
            },
            error: function(request, status, err) {
                clear.removeClass('hidden');
                if(status === 'timeout') {
                    status.text('Превышено время выполнения запроса. Повторите попытку позже.');
                } else {
                    status.text('При выполнении поискового запроса произошла ошибка. Пожалуйста, сообщите об этом администрации.');
                }
                results.addClass('hidden').html('');
                setEnabled(true);
                ready = true;
            }
        });
    });

    clear.click(function() {
        clear.addClass('hidden');
        button.removeClass('hidden');
        block.addClass('hidden');
    });

    /**
     * Делает активными/неактивными элементы управления
     * @return {undefined}
     */
    function setEnabled(enabled) {
        if (enabled === true) {
            input.removeAttr('disabled').prop('disabled', false);
            button.removeAttr('disabled').prop('disabled', false);
        } else {
            input.attr('disabled', 'disabled').prop('disabled', true);
            button.attr('disabled', 'disabled').prop('disabled', true);
        }
    }
}

/**
 * Функционал заполнения тегов раздачи
 * @return {undefined}
 */
function _nAddFormTags() {
    var input = $('#suggEdit');
    var button = $('.addform__field-tags');
    button.click(function() {
        var checkboxes = $('.addform-categories__children input[type="checkbox"]:checked');
        if (!checkboxes || checkboxes && !checkboxes.length) {
            _uWnd.alert('Выберите хотя бы одну категорию', 'Внимание', { w: 250, h: 92, tm: 3500 });
        }
        var categories = [];
        checkboxes.each(function() {
            var name = this.nextElementSibling.innerText;
            if (name === 'Работа с CD / DVD дисками') {
                name = 'Работа с CD и DVD дисками';
            }
            if (name === 'Rap / Hip-hop / R n B' || name === 'Pop / Dance / Club' || name === 'Rock / Metal / Alternative') {
                name = name.replace(/ \/ /g, ', ');
            }
            if (name === 'Jazz / Blues / Блюз') {
                name = name.substring(0, name.lastIndexOf(' /'));
                name = name.replace(/ \/ /g, ', ');
            }
            if (name.indexOf('/') !== -1) {
                name = name.substring(0, name.indexOf('/')).trim();
            }
            categories.push(name.trim());
        });
        input.val(categories.join(', '));
    });
}

/**
 * Выполняет поиск ссылки трейлера на youtube.com и задает значение полю "Трейлер"
 * @return {undefined}
 */
function _nAddFormTrailer() {
    if (+_nAddFormSectionId !== 1) {
        return;
    }
    var name = $('#ldF1');
    var trailer = $('#ldF16');
    if (!name || !trailer || name && !name.val() || trailer && trailer.is(':hidden') || name.val() && !trailer.is(':hidden') && trailer.val()) {
        return;
    }
    $.ajax({
        type: 'GET',
        url: 'http://n-torrents.com/v3/trailer.php?query=' + name.val(),
        timeout: 8000,
        success: function(data) {
            try {
                json = JSON.parse(data);
                console.dir(json);
                if (json && json.status && json.status === 'success' && json.url) {
                    trailer.val(json.url);
                }
            } catch (exception) {}
        }
    });
}

/**
 * Заменяет всплывающие подсказки скрипта datalist.js
 * @return {undefined}
 */
function _nAddFormSuggests() {
    var containers = document.querySelectorAll('.js-suggest');
    if (!containers || containers && !containers.length) {
        return;
    }
    for (var i = 0; i < containers.length; i++) {
        behavior(containers[i]);
    }

    /**
     * Задает поведение текстового поля и списка подсказок в контейнере
     * @param {HTMLElement} container - блок с классом js-suggest
     * @return {undefined}
     */
    function behavior(container) {
        var input = container.querySelector('input.input_extrafl');
        if (!input) {
            return;
        }
        var list_html;
        var options = container.querySelectorAll('option');
        if (options && options.length) {
            // если скрипт выполняется до /.s/src/datalist/datalist.js, то на сайте все еще есть <datalist> с вариантами
            list_html = options.innerHTML.replace(/<option>/gi, '<li>').replace(/<\/option>/gi, '</li>');
        } else if (input.getAttribute('list') && input.getAttribute('list').length) {
            // если скрипт выполняется после /.s/src/datalist/datalist.js
            var previously_rendered = document.querySelector('#' + input.getAttribute('list'));
            if (previously_rendered) {
                list_html = previously_rendered.innerHTML.replace(/<li[^>]*>/gi, '<li>');
            }
        }
        if (!list_html) {
            console.error('В контейнере не найден список подсказок.');
            console.dir(container);

            return;
        }
        // пересоздаем текстовое поле для сброса EventListener'ов
        var new_input = input.cloneNode(true);
        input.parentNode.replaceChild(new_input, input);
        input = new_input;
        // создаем список вариантов
        var list = document.createElement('ul');
        var visible = 0; // количество видимых элементов после фильтрации
        var active; // активный (выбранный) элемент списка
        list.className = 'suggest-list';
        list.innerHTML = sortedItems(list_html);
        list.style.display = 'none';
        for (var l = 0; l < list.children.length; l++) {
            list.children[l].lowerValue = list.children[l].innerText.toLowerCase();
            list.children[l].style.display = 'none';
            list.children[l].addEventListener('click', function() {
                if (active) {
                    active.className = '';
                }
                this.className = 'active';
                active = this;
                input.value = this.innerText;
                list.style.display = 'none';
            });
        }
        container.appendChild(list);
        input.addEventListener('keyup', function() {
            var value = input.value;
            value = value && value.length ? value.toLowerCase() : null;
            if (!value) {
                if (list.style.display === 'block') {
                    list.style.display = 'none';
                }

                return;
            }
            visible = 0;
            for (var i = 0; i < list.children.length; i++) {
                if (list.children[i].lowerValue.indexOf(value) === -1) {
                    if (list.children[i].style.display === 'block') {
                        list.children[i].style.display = 'none';
                    }
                } else {
                    if (list.children[i].style.display === 'none') {
                        list.children[i].style.display = 'block';
                    }
                    visible++;
                }
            }
            if (!visible && list.style.display === 'block') {
                list.style.display = 'none';
            } else if (visible && list.style.display === 'none') {
                list.style.display = 'block';
            }
        });
        input.addEventListener('focus', function() {
            if (visible && list.style.display === 'none') {
                list.style.display = 'block';
            }
        });
        input.addEventListener('blur', function() {
            if (list.style.display === 'block') {
                setTimeout(function() {
                    list.style.display = 'none';
                }, 100);
            }
        });
    }

    /**
     * Сортирует html-код ссылок
     * @param {String} html - код элементов списка
     * @return {String}
     */
    function sortedItems(html) {
        var matches = html.match(/<li>.*?<\/li>/gi);
        if (!matches || matches && !matches.length) {
            return html;
        }
        var sorted = [];
        for (var i = 0; i < matches.length; i++) {
            sorted.push(matches[i]);
        }
        sorted = sorted.sort(function (a, b) {
            if (a.toLowerCase() > b.toLowerCase()) {
                return 1;
            }
            if (a.toLowerCase() < b.toLowerCase()) {
                return -1;
            }
            return 0;
        });

        return sorted.join('');
    }
}

/**
 * Форматирует чекбоксы настроек раздачи
 * @return {undefined}
 */
function _nAddFormFormatSettings() {
    var block = $('.addform__settings');
    if (!block) {
        return;
    }
    var labels = block.find('label');
    if (!labels) {
        return;
    }
    labels.each(function() {
        var self = $(this);
        var checkbox = self.find('input[type="checkbox"]');
        if (!checkbox) {
            return;
        }
        // вытаскиваем чекбокс и label'а
        self.before(checkbox);
        self.attr('for', checkbox.attr('id'));
    });
    // оставляем в блоке только checkbox + label, обёрнутые в <div>
    var matches = block.html().match(/<input.*?>\s*<label.*?<\/label>/gi);
    if (matches && matches.length) {
        block.html('<div class="addform__settings-row switcher">' + matches.join('</div><div class="addform__settings-row switcher">') + '</div>');
    }
    // проставляем доп. классы <div class="addform__settings-row"> для возможности скрытия, например, чекбокса "Позволить оставлять комментарии"
    var rows = block.find('.addform__settings-row');
    if (rows) {
        rows.each(function() {
            var self = $(this);
            var checkbox = self.find('input[type="checkbox"]');
            if (!checkbox) {
                return;
            }
            self.addClass('addform__settings-row_' + checkbox.attr('name').replace('_', '-'));
        });
    }
    block.removeClass('hidden');
}

/**
 * Возвращает массив ошибок валидации полей
 * @return {Array}
 */
function _nAddFormValidate() {
    var errors = [];
    if (!_nAddFormFields || _nAddFormFields && !_nAddFormFields.length) {
        return errors;
    }
    _nAddFormFields.each(function() {
        var parent = $(this);
        var name = parent.find('.addform__field-name, .addform-categories__title');
        if (name && name.length) {
            name = name.eq(0).text().trim();
        }
        if (parent.hasClass('hidden')) {
            return;
        }
        var matches = this.className.match(/js_validate-([\w-_]+)/i);
        if (!matches || matches && matches.length < 2) {
            console.error('Не указан класс с модификатором типа валидируемого поля');
            console.dir(this);

            return;
        }
        switch(matches[1]) {
            case 'text':
                parent.find('input[type="text"], input[type="url"], textarea').each(function() {
                    if (!this.value || this.value && this.value === '') {
                        errors.push(name ? 'Не заполнено обязательное поле "' + name + '"' : 'Не заполнено одно из обязательных полей');
                    }
                });
                break;
            case 'checkbox':
                var checkboxes = parent.find('input[type="checkbox"]:checked');
                if (!checkboxes || checkboxes && !checkboxes.length) {
                    errors.push(name ? 'Не заполнено обязательное поле "' + name + '"' : 'Не заполнено одно из обязательных полей');
                }
                break;
            case 'selectbox':
                parent.find('select').each(function() {
                    if (!this.options[this.selectedIndex].value || this.options[this.selectedIndex].value === '0') {
                        errors.push(name ? 'Не заполнено обязательное поле "' + name + '"' : 'Не заполнено одно из обязательных полей');
                    }
                });
                break;
            case 'file':
                parent.find('input[type="file"]').each(function() {
                    var self = $(this);
                    var file = self.val() && self.val() !== '' ? self.val() : null;
                    var existing = self.parent().find('a');
                    // в случае, когда файл уже загружен, валидация расширения файла не требудется, дабы не выпилить возможность удалять файлы
                    if (existing && existing.length) {
                        return;
                    }
                    if (!file) {
                        errors.push(name ? 'Вы выбран файл "' + name + '"' : 'Не выбран файл в одном из обязательных полей');

                        return;
                    } else if (file && parent.attr('class').indexOf('js_validate-extension_') !== -1) {
                        var matches = parent.attr('class').match(/js_validate-extension_([\w\d]+)/i);
                        if (!matches || matches && !matches.length) {
                            console.error('Не указан модификатор класса валидации расширения загружаемого файла');

                            return;
                        }
                        matches[1] = matches[1].toLowerCase();
                        file = file.toLowerCase();
                        if (file.search(new RegExp('[.]' + matches[1] + '$', 'i')) === -1) {
                            errors.push(name ? 'Загружаемый файл "' + name + '" должен иметь расширение .' + matches[1] : 'Загружаемый файл одного из полей должен иметь расширение .' + matches[1]);
                        }
                    }
                });
                break;
            default:
                break;
        }
    });

    return errors;
}

/**
 * Функционал клика по кнопке "Отправить"
 * @return {undefined}
 */
function _nAddFormSubmit() {
    var submit = $('#doSmbBt');
    var loading = $('.addform__load');
    var preloader = loading.find('.preloader');
    var message = loading.find('.addform__load-message');
    var ready = true;
    $('.addform__submit').click(function() {
        if (!ready) {
            return;
        }
        ready = false;
        var errors = _nAddFormValidate();
        if (errors && errors.length) {
            _uWnd.alert(errors[0], 'Внимание', { w: 250, h: 92, tm: 3500 });
            ready = true;

            return;
        }
        loading.removeClass('hidden');
        var timeout = 5; // таймаут отправки формы, значение в секундах
        var sending = setInterval(function() {
            var redirect_link = $('.myWinCont a[target="_blank"]');
            if (redirect_link && redirect_link.length && redirect_link.attr('href')) {
                clearInterval(sending);
                var link = redirect_link.attr('href');
                preloader.addClass('hidden');
                if (link) {
                    message.text('Загрузка успешно завершена. Перенаправление...').removeClass('hidden');
                    setTimeout(function() {
                        location.href = link;
                    }, 3500);
                    location.href = link;
                } else {
                    message.text('Ошибка перенаправления.').removeClass('hidden');
                    setTimeout(function() {
                        loading.addClass('hidden');
                        preloader.removeClass('hidden');
                        message.addClass('hidden');
                        ready = true;
                    }, 3500);
                }
            } else {
                timeout--;
                if (timeout <= 0) {
                    clearInterval(sending);
                    preloader.addClass('hidden');
                    message.text('Превышено время ожидания сервера.').removeClass('hidden');
                    setTimeout(function() {
                        loading.addClass('hidden');
                        preloader.removeClass('hidden');
                        message.addClass('hidden');
                        ready = true;
                    }, 3500);
                }
            }
        }, 1000);
        submit.click();
    });
}